# Generated with SMOP  0.41
# from smop.libsmop import *
# Link.m
    
# @function
import numpy as np


def Link(n=None,q=None,enter=None,green_time=None,C_down=None,para=None,sigma_pre=None,beta=None,*args,**kwargs):
    # varargin = Link.varargin
    # nargin = Link.nargin

    ## LINK_3 update the states of the lanes
# q denotes the queueon current lane
# n is the total number of vehicles on the lane;
# enter is the entering flow vector for the lane at time k-1,k, veh/h, is calculated in advance
# the green_time is the green light time for the lane within current cycle, with the unit as second for convenience
# para=[vehicle_length; link_length; saturating_flow_rate; free_flow_speed]   
# C_down is the available capacity of the downstream lane
##
    cycle_time=60
    cd=cycle_time
    l_veh=para[0]
    l_link=para[1]
    mu=para[2:5]
    v_free=para[5] / 3.6
    N_lane=para[6]
    q_sum=sum(q)
    if np.isnan(q_sum):
        pass
    C=np.multiply(N_lane,l_link) // l_veh
    tao_p=sigma_pre[0]
    gama_p=sigma_pre[1]
    leave=np.zeros(3)
    if tao_p < 0:
        gama_p=0
        tao_p=0
    elif tao_p > 1:
        tao_p=1
        gama_p=cd
    tao_c=(np.multiply((C - q_sum),l_veh)) // (np.multiply(np.multiply(N_lane,v_free),cd))
    gama_c=((np.multiply(l_veh,(C - q_sum))) / (np.multiply(N_lane,v_free))) % cd
# Link.m:28
    
    if tao_c < 0:
        gama_c=0
        tao_c=0
    elif tao_c > 1:
        tao_c=1
        gama_c=cd
    n_tao=abs(tao_p + 1 - tao_c)
    if np.isnan(n_tao):
        pass
    try:
        B=np.zeros(int(n_tao) + 1)
    except ValueError:
        pass
    if n_tao == 0:
        B[0]=(gama_p - gama_c) / cd
    elif tao_p + 1 > tao_c:
        B[0]=gama_p / cd
        B[-1]=1 - gama_c / cd
        B[1:-1]=1
    elif tao_p + 1 < tao_c:
        B[1]=- gama_c / cd
        B[-1]=- (1 - gama_p / cd)
        B[1:-1]=1
    
    arrival=0
    for i in range(0,int(n_tao)+1):
        arrival=arrival + np.multiply(B[i],enter[-1 - max(int(tao_p) + 1,int(tao_c)) + i])
    arriv_1=np.multiply(arrival,beta[0])
    arriv_2=np.multiply(arrival,beta[1])
    arriv_3=np.multiply(arrival,beta[2])
    arriv=np.array([arriv_1,arriv_2,arriv_3])
    green_l=green_time[0]
    green_m=green_time[1]
    green_r=green_time[2]
    Vector1=np.array([np.multiply(mu[0],green_l) / cd,np.multiply(q[0] / cd,3600) + arriv_1,np.multiply(C_down[0] / cd,3600)])
    Vector2=np.array([np.multiply(mu[1],green_m) / cd,np.multiply(q[1] / cd,3600) + arriv_2,np.multiply(C_down[1] / cd,3600)])
    Vector3=np.array([np.multiply(mu[2],green_r) / cd,np.multiply(q[2] / cd,3600) + arriv_3,np.multiply(C_down[2] / cd,3600)])
    leave[0]=np.nanmin(Vector1)
    leave[1]=np.nanmin(Vector2)
    leave[2]=np.nanmin(Vector3)
    sigma=np.array([tao_c,gama_c])
    q[0]=q[0] + np.multiply((arriv_1 - leave[0]),cd) / 3600
    q[1]=q[1] + np.multiply((arriv_2 - leave[1]),cd) / 3600
    q[2]=q[2] + np.multiply((arriv_3 - leave[2]),cd) / 3600
    n[0]=n[0] + np.multiply((np.multiply(enter[-1],beta[0]) - leave[0]),cd) / 3600
    n[1]=n[1] + np.multiply((np.multiply(enter[-1],beta[1]) - leave[1]),cd) / 3600
    n[2]=n[2] + np.multiply((np.multiply(enter[-1],beta[2]) - leave[2]),cd) / 3600
    return n,q,leave,arriv,sigma
    
if __name__ == '__main__':
    pass
    