import numpy as np

def Pro3(g=None,*args,**kwargs):
    # varargin = Pro3.varargin
    # nargin = Pro3.nargin
    epsilon=0.1
    if any(g - np.dot(6,np.ones(3)) < - epsilon) or any(g - np.dot(42,np.ones(3)) > epsilon):
        P1=np.array([[5 / 6,1 / 3,- 1 / 6],[1 / 3,1 / 3,1 / 3],[- 1 / 6,1 / 3,5 / 6]])
        P2=np.array([[1 / 3,1 / 3,1 / 3],[1 / 3,5 / 6,- 1 / 6],[1 / 3,- 1 / 6,5 / 6]])
        P3=np.array([[5 / 6,- 1 / 6,1 / 3],[- 1 / 6,5 / 6,1 / 3],[1 / 3,1 / 3,1 / 3]])
        v1=np.array([6,6,42])
        v2=np.array([6,42,6])
        v3=np.array([42,6,6])
        # Projection 1
        d_1=g - v1
        d_1_pro=np.dot(P1,d_1)
        g1=d_1_pro + v1
        # Projection 2
        d_2=g - v2
        d_2_pro=np.dot(P2,d_2)
        g2=d_2_pro + v2
        # Projection 3
        d_3=g - v3
        d_3_pro=np.dot(P3,d_3)
        g3=d_3_pro + v3
        G_pro=np.array([g1,g2,g3])
        V=np.array([v1,v2,v3])
        G_pro_inside=np.zeros((3,3))
        # find all the projection points that are inside of the region
        counter=0
        for i in range(3):
            if all(G_pro[i] - np.dot(6,np.ones(3)) >= - epsilon) and all(G_pro[i] - np.dot(42,np.ones(3)) <= epsilon):
                G_pro_inside[counter,:]=G_pro[i,:]
                counter = counter + 1
        G_pro_inside=G_pro_inside[0:counter,:]
        G=np.concatenate((G_pro_inside,V))
        dist=np.empty(counter + 3)
        for i in range(counter + 3):
            dist[i]=np.linalg.norm(g - G[i,:])
        distance=np.nanmin(dist)
        index=np.argmin(dist)
        g_pro=G[index,:]
        return g_pro,distance
    else:
        g_pro=np.copy(g)
        distance=0
        return g_pro,distance
    