import numpy as np

def Pro4(g=None,*args,**kwargs):
    # varargin = Pro4.varargin
    # nargin = Pro4.nargin
    epsilon=0.1
    if any(g - np.dot(6,np.ones(4)) < - epsilon) or any(g - np.dot(34,np.ones(4)) > epsilon):
        P1=np.array([[11 / 12,- 1 / 12,- 1 / 12,1 / 4],[- 1 / 12,11 / 12,- 1 / 12,1 / 4],[- 1 / 12,- 1 / 12,11 / 12,1 / 4],[1 / 4,1 / 4,1 / 4,1 / 4]])
        P2=np.array([[1 / 4,1 / 4,1 / 4,1 / 4],[1 / 4,11 / 12,- 1 / 12,- 1 / 12],[1 / 4,- 1 / 12,11 / 12,- 1 / 12],[1 / 4,- 1 / 12,- 1 / 12,11 / 12]])
        P4=np.array([[11 / 12,- 1 / 12,1 / 4,- 1 / 12],[- 1 / 12,11 / 12,1 / 4,- 1 / 12],[1 / 4,1 / 4,1 / 4,1 / 4],[- 1 / 12,- 1 / 12,1 / 4,11 / 12]])
        P3=np.array([[11 / 12,1 / 4,- 1 / 12,- 1 / 12],[1 / 4,1 / 4,1 / 4,1 / 4],[- 1 / 12,1 / 4,11 / 12,- 1 / 12],[- 1 / 12,1 / 4,- 1 / 12,11 / 12]])
        v1=np.array([34,6,6,6])
        v2=np.array([6,34,6,6])
        v3=np.array([6,6,34,6])
        v4=np.array([6,6,6,34])
        # Projection 1
        d_1=g - v1
        d_1_pro=np.dot(P1,d_1)
        g1=d_1_pro + v1
        # Projection 2
        d_2=g - v2
        d_2_pro=np.dot(P2,d_2)
        g2=d_2_pro + v2
        # Projection 3
        d_3=g - v3
        d_3_pro=np.dot(P3,d_3)
        g3=d_3_pro + v3
        # Projection 4
        d_4=g - v4
        d_4_pro=np.dot(P4,d_4)
        g4=d_4_pro + v4

        G_pro=np.array([g1,g2,g3,g4])
        V=np.array([v1,v2,v3,v4])
        G_pro_inside=np.zeros((4,4))

        counter1=0
        for i in range(4):
            if all(G_pro[i] - np.dot(6,np.ones(4)) >= - epsilon) and all(G_pro[i] - np.dot(34,np.ones(4)) <= epsilon):
                G_pro_inside[counter1]=G_pro[i]
                counter1 = counter1 + 1
        G_pro_inside=G_pro_inside[0:counter1]
        # Do 6 projections on all the 6 lines
        G_pro_line=np.zeros((6,4))
        G_pro_line_inside=np.zeros((6,4))
        x0=g[0];y0=g[1];z0=g[2];d0=g[3]
        x1=6
        y1=6
        z1=(40 + z0 - d0) / 2
        d1=40 - z1
        G_pro_line[0]=np.array([x1,y1,z1,d1])
        x2=6;y2=(40 + y0 - d0) / 2;z2=6;d2=40 - y2
        G_pro_line[1]=np.array([x2,y2,z2,d2])
        x3=6
        y3=(40 + y0 - z0) / 2
        z3=40 - y3
        d3=6
        G_pro_line[2]=np.array([x3,y3,z3,d3])
        x4=(40 + x0 - d0) / 2
        y4=6
        z4=6
        d4=40 - x4
        G_pro_line[3]=np.array([x4,y4,z4,d4])
        x5=(40 + x0 - z0) / 2
        y5=6
        z5=40 - x5
        d5=6
        G_pro_line[4]=np.array([x5,y5,z5,d5])
        x6=(40 + x0 - y0) / 2
        y6=40 - x6
        z6=6
        d6=6
        G_pro_line[5]=np.array([x6,y6,z6,d6])
        counter2=0
        for i in range(6):
            if all(G_pro_line[i] - np.dot(6,np.ones(4)) >= - epsilon) and all(G_pro_line[i] - np.dot(34,np.ones(4)) <= epsilon):
                G_pro_line_inside[counter2]=G_pro_line[i]
                counter2 = counter2 + 1
        G_pro_line_inside=G_pro_line_inside[0:counter2]
        G=np.concatenate((G_pro_inside,G_pro_line_inside,V))
        dist=np.empty(counter1 + counter2 + 4)
        for i in range(counter1 + counter2 + 4):
            dist[i]=np.linalg.norm(g - G[i])
        distance = np.nanmin(dist)
        index = np.argmin(dist)
        g_pro=G[index]
        return g_pro,distance
    else:
        g_pro=np.copy(g)
        distance=0
        return g_pro,distance
    